#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>
#include <sys/types.h>

// Exit status to use when launching an AppImage fails.
// For applications that assign meanings to exit status codes (e.g. rsync),
// we avoid "cluttering" pre-defined exit status codes by using 127 which
// is known to alias an application exit status and also known as launcher
// error, see SYSTEM(3POSIX).
#define EXIT_EXECERROR 127

ssize_t slimpack_get_offset(const char *executable);
int slimpak_isolate(const char *root_dir, char **argv);
int slimpak_mount(const char *executable, const char *work_dir, const char *root_dir);
int slimpak_unmount(const char *work_dir, const char *root_dir);
