/*
* License: BSD-style license
* Copyright: Radek Podgorny <radek@podgorny.cz>,
*            Bernd Schubert <bernd-schubert@gmx.de>
*/

#pragma once

#include <fuse.h>
#include <squashfuse/squashfuse.h>

#include <stdbool.h>

typedef struct {
	struct fuse *fuse;
	struct fuse_chan *channel;
	struct sqfs image;
	char root_dir[PATH_MAX];
	char target_dir[PATH_MAX];
} *slimfs_t;

extern struct fuse_operations unionfs_oper;

slimfs_t slimfs_new(int argc, char **argv, const char *target_dir, const char *root_dir, const char *img_path, size_t img_offset);
void slimfs_free(slimfs_t fs);
