local ostree = require "ostree";

return function (options, name, out)
	local repo = ostree.from_http(options.repo);
	local ref = repo:read_ref(name);
	local commit = repo:read_commit(ref);

	local root = repo:read_dir(commit.root);

	root:recurse(repo, function (path, node)
		return ostree.dump_node(out .. path, node);
	end);
end
